/*
 * Copyright 2009 Yuichiro Moriguchi
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package net.morilib.lisp.lite;

import java.io.StringReader;

import net.morilib.lisp.lite.subr.UnaryArgs;

public class ExSubrOpenInputString extends UnaryArgs {

	@Override
	protected Datum execute(
			Datum c1a, Environment env, LispMessage mesg) {
		if(c1a instanceof LispString) {
			String fname = ((LispString)c1a).getString();
			
			return new InputPort(new StringReader(fname), mesg);
		} else {
			throw mesg.getError("err.require.string", c1a);
			//throw new LispException("string required");
		}
	}

}
