/*
 * Copyright 2009 Yuichiro Moriguchi
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package net.morilib.lisp.lite;

import net.morilib.util.Objects;

/**
 * 
 *
 *
 * @author MORIGUCHI, Yuichiro 2009
 */
public abstract class NamableDatum extends Datum {

	//
	private String name;

	/**
	 * 
	 * @param name
	 */
	public NamableDatum(String name) {
		this.name = name;
	}

	/**
	 * 
	 * @return
	 */
	public abstract String display();

	/**
	 * 
	 * @return
	 */
	public String printName() {
		return (name == null) ? Objects.printHash(this) : name;
	}

	/**
	 * 
	 * @return
	 */
	public String getName() {
		return name;
	}

	//
	/*package*/ void setName(String name) {
		this.name = name;
	}

	/* (non-Javadoc)
	 * @see net.morilib.lisp.Datum#toDisplayString(java.lang.StringBuilder)
	 */
	@Override
	public void toDisplayString(StringBuilder buf) {
		buf.append(display());
	}

}
