/*
 * Copyright 2009 Yuichiro Moriguchi
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package net.morilib.lisp.lite.exlib;

import net.morilib.lisp.lite.Datum;
import net.morilib.lisp.lite.Environment;
import net.morilib.lisp.lite.LispMessage;
import net.morilib.lisp.lite.Nil;
import net.morilib.lisp.lite.Subr;
import net.morilib.lisp.lite.Symbol;

public class Gensym extends Subr {

	@Override
	public Datum eval(Datum body, Environment env, LispMessage mesg) {
		if(body == Nil.NIL) {
			return Symbol.gensym();
		} else {
			throw mesg.getError("err.argument");
		}
	}

}
