/*
 * Copyright 2009 Yuichiro Moriguchi
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package net.morilib.lisp.lite.subr;

import net.morilib.lisp.lite.Datum;
import net.morilib.lisp.lite.EOFObject;
import net.morilib.lisp.lite.Environment;
import net.morilib.lisp.lite.InputPort;
import net.morilib.lisp.lite.LispBoolean;
import net.morilib.lisp.lite.LispMessage;

public class IsEofObject extends UnaryArgs {

	@Override
	protected Datum execute(Datum c1a, Environment env, LispMessage mesg) {
		boolean res;
		
		if(c1a instanceof InputPort) {
			res = ((InputPort)c1a).isReachedEOF();
		} else {
			res = c1a == EOFObject.EOF;
		}
		
		return LispBoolean.getInstance(res);
	}
	
}
